'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

var _defaultRanges = require('../defaultRanges');

var _DayCell = require('./DayCell');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _reactTextMask = require('react-text-mask');

var _reactTextMask2 = _interopRequireDefault(_reactTextMask);

var _createAutoCorrectedDatePipe = require('text-mask-addons/dist/createAutoCorrectedDatePipe');

var _createAutoCorrectedDatePipe2 = _interopRequireDefault(_createAutoCorrectedDatePipe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var autoCorrectedDatePipe = (0, _createAutoCorrectedDatePipe2.default)('mm/dd/yyyy', {
  minYear: '2017',
  maxYear: new Date().getFullYear().toString()
});

function getDateForPickersInterval(dateD) {
  var date = new Date(dateD);
  var monthNumber = +date.getMonth() + 1;
  var year = date.getFullYear();
  var month = monthNumber.toString().length < 2 ? '0' + monthNumber : monthNumber;
  var day = date.getDate().toString().length < 2 ? '0' + date.getDate() : date.getDate();

  return month.toString() + day.toString() + year.toString();
}

function getDateFromMask(maskString) {
  var maskNumbers = maskString.split('/');
  return new Date(+maskNumbers[2], +maskNumbers[0] - 1, +maskNumbers[1]);
}

function TextMaskCustom(props) {
  var inputRef = props.inputRef,
      other = _objectWithoutProperties(props, ['inputRef']);

  return _react2.default.createElement(_reactTextMask2.default, _extends({}, other, {
    ref: inputRef,
    mask: [/\d/, /\d/, '/', /\d/, /\d/, '/', /\d/, /\d/, /\d/, /\d/],
    placeholderChar: '\u2000',
    showMask: true,
    pipe: autoCorrectedDatePipe
  }));
}

var DefinedRanges = function (_Component) {
  _inherits(DefinedRanges, _Component);

  function DefinedRanges(props) {
    _classCallCheck(this, DefinedRanges);

    var _this = _possibleConstructorReturn(this, (DefinedRanges.__proto__ || Object.getPrototypeOf(DefinedRanges)).call(this, props));

    _this.state = {
      rangeOffset: 0,
      focusedInput: -1,
      textmasks: {
        startDate: '',
        endDate: ''
      }
    };
    _this.handleRangeChange = _this.handleRangeChange.bind(_this);
    _this.handleChangeTextMask = _this.handleChangeTextMask.bind(_this);
    _this.getCurrentTextmaskValue = _this.getCurrentTextmaskValue.bind(_this);
    return _this;
  }

  _createClass(DefinedRanges, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateTextmasks();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.ranges !== this.props.ranges) {
        this.updateTextmasks();
      }
    }
  }, {
    key: 'updateTextmasks',
    value: function updateTextmasks() {
      var _props = this.props,
          ranges = _props.ranges,
          focusedRange = _props.focusedRange;

      var selectedRange = ranges[focusedRange[0]];
      if (!selectedRange.startDate || !selectedRange.endDate || selectedRange.disabled) return false;
      this.setState({
        textmasks: {
          startDate: getDateForPickersInterval(selectedRange.startDate),
          endDate: getDateForPickersInterval(selectedRange.endDate)
        }
      });
    }
  }, {
    key: 'handleRangeChange',
    value: function handleRangeChange(range) {
      var _props2 = this.props,
          onChange = _props2.onChange,
          ranges = _props2.ranges,
          focusedRange = _props2.focusedRange;

      var selectedRange = ranges[focusedRange[0]];
      if (!onChange || !selectedRange) return;
      onChange(_defineProperty({}, selectedRange.key || 'range' + (focusedRange[0] + 1), _extends({}, selectedRange, range)));
    }
  }, {
    key: 'getSelectedRange',
    value: function getSelectedRange(ranges, staticRange) {
      var focusedRangeIndex = ranges.findIndex(function (range) {
        if (!range.startDate || !range.endDate || range.disabled) return false;
        return staticRange.isSelected(range);
      });
      var selectedRange = ranges[focusedRangeIndex];
      return { selectedRange: selectedRange, focusedRangeIndex: focusedRangeIndex };
    }
  }, {
    key: 'handleChangeTextMask',
    value: function handleChangeTextMask(event, name) {
      if (event.target.value.toString().trim().length === 10) {
        var _props3 = this.props,
            ranges = _props3.ranges,
            focusedRange = _props3.focusedRange;

        var selectedRange = ranges[focusedRange[0]];
        if (name === 'startDate') {
          var startDate = getDateFromMask(event.target.value);
          var endDate = selectedRange.endDate;
          if (startDate.getTime() > endDate.getTime()) {
            this.handleRangeChange({
              startDate: startDate,
              endDate: startDate
            });
            return;
          }
        }
        if (name === 'endDate') {
          var _endDate = getDateFromMask(event.target.value);
          var _startDate = selectedRange.startDate;
          if (_startDate.getTime() > _endDate.getTime()) {
            this.handleRangeChange({
              startDate: _endDate,
              endDate: _endDate
            });
            return;
          }
        }
        this.handleRangeChange(_defineProperty({}, name, getDateFromMask(event.target.value)));
      }
    }
  }, {
    key: 'getCurrentTextmaskValue',
    value: function getCurrentTextmaskValue(name) {
      var textmasks = this.state.textmasks;

      return textmasks[name];
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props4 = this.props,
          ranges = _props4.ranges,
          rangeColors = _props4.rangeColors,
          className = _props4.className;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(_styles2.default.definedRangesWrapper, className) },
        this.props.headerContent,
        _react2.default.createElement(
          'div',
          { className: _styles2.default.staticRanges },
          this.props.staticRanges.map(function (staticRange, i) {
            var _getSelectedRange = _this2.getSelectedRange(ranges, staticRange),
                selectedRange = _getSelectedRange.selectedRange,
                focusedRangeIndex = _getSelectedRange.focusedRangeIndex;

            return _react2.default.createElement(
              'button',
              {
                type: 'button',
                className: (0, _classnames2.default)(_styles2.default.staticRange, _defineProperty({}, _styles2.default.staticRangeSelected, Boolean(selectedRange))),
                style: {
                  color: selectedRange ? selectedRange.color || rangeColors[focusedRangeIndex] : null
                },
                key: i,
                onClick: function onClick() {
                  return _this2.handleRangeChange(staticRange.range(_this2.props));
                }
              },
              _react2.default.createElement(
                'span',
                { tabIndex: -1, className: _styles2.default.staticRangeLabel },
                staticRange.label
              )
            );
          })
        ),
        _react2.default.createElement(
          'div',
          { className: _styles2.default.inputRanges },
          this.props.inputRanges.map(function (rangeOption, i) {
            return _react2.default.createElement(
              _FormControl2.default,
              { className: _styles2.default.inputRange, key: i },
              _react2.default.createElement(
                _InputLabel2.default,
                { className: _styles2.default.inputRangeLabel },
                rangeOption.label
              ),
              _react2.default.createElement(_Input2.default, {
                className: _styles2.default.inputRangeInput,
                onFocus: function onFocus() {
                  return _this2.setState({ focusedInput: i, rangeOffset: 0 });
                },
                onBlur: function onBlur() {
                  return _this2.setState({ rangeOffset: 0 });
                },
                value: _this2.getCurrentTextmaskValue(rangeOption.name),
                onChange: function onChange(e) {
                  _this2.handleChangeTextMask(e, rangeOption.name);
                },
                inputComponent: TextMaskCustom
              })
            );
          })
        ),
        this.props.footerContent
      );
    }
  }]);

  return DefinedRanges;
}(_react.Component);

DefinedRanges.propTypes = {
  inputRanges: _propTypes2.default.array,
  staticRanges: _propTypes2.default.array,
  ranges: _propTypes2.default.arrayOf(_DayCell.rangeShape),
  focusedRange: _propTypes2.default.arrayOf(_propTypes2.default.number),
  onPreviewChange: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  footerContent: _propTypes2.default.any,
  headerContent: _propTypes2.default.any,
  rangeColors: _propTypes2.default.arrayOf(_propTypes2.default.string),
  className: _propTypes2.default.string
};

DefinedRanges.defaultProps = {
  inputRanges: _defaultRanges.defaultInputRanges,
  staticRanges: _defaultRanges.defaultStaticRanges,
  ranges: [],
  rangeColors: ['#3d91ff', '#3ecf8e', '#fed14c'],
  focusedRange: [0, 0]
};

exports.default = DefinedRanges;